#include "ledblinker.h"
#include "factory/factory.h"
#include "../board/led/led.h"

void LEDBlinker_init(LEDBlinker* me) {
    me->state = ST_LBINIT;
}

void LEDBlinker_startBehaviour(LEDBlinker* me) {
    POST(me, &LEDBlinker_processEvent, evLBInit,0,0);
}

bool LEDBlinker_processEvent(Event* ev) {
    bool processed = false;
    LEDBlinker* me = (LEDBlinker*)Event_getTarget(ev);
    LBSTATES oldState = me->state;
    evIDT evid = Event_getId(ev);
    
    switch (me->state) {
        case ST_LBINIT:
            if (evid == evLBInit) {
                me->state = ST_LBOFF;
            }
            break;
        case ST_LBOFF:
            if (evid == evLBTMOn) {
                me->state = ST_LBON;
            }
            break;
        case ST_LBON:
            if (evid == evLBTMOff) {
                me->state = ST_LBOFF;
            }
            break;
        default:
            break;
    }
    
    if (oldState != me->state) {
        switch (me->state) {
            case ST_LBINIT:
                break;
            case ST_LBOFF:
                LED_off(l1());
                POST(me, &LEDBlinker_processEvent, evLBTMOn,TMOFF,0);
                break;
            case ST_LBON:
                LED_on(l1());
                POST(me, &LEDBlinker_processEvent, evLBTMOff,TMON,0);
                break;
            default:
                break;
        }   
        processed = true;
    }
    return processed;
}